var canvas, context;
var gImage;
var WIDTH, HEIGHT;
var frameRate = 5;
var refreshCount = 0;
var battery;
var currentFrame;
var TIMELINE_MAX_VALUE = 24 * 60 * 60 * frameRate;
var dayOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var dayOfWeekFull = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthStr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var monthStrFull = ["January", "Febuary", "March", "April", "May", "Jun", "July", "August", "September", "October", "November", "December"];
var maximumDays = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];

var Background1ButtonArea = [0, 0, 360, 360];
var Background1ButtonIndex = 0;
var Background1ButtonImage = ["4.png"];
var imghrpng = new Image();
var imgminpng = new Image();
var imgsecpng = new Image();

window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function (/* function */ callback) {
        'use strict';
        window.setTimeout(callback, 1000 / frameRate);
    };

function getDate() {
    'use strict';

    var date;
    try {
        date = tizen.time.getCurrentDateTime();
    } catch (err) {
        console.error('Error: ', err.message);
        date = new Date();
    }

    return date;
}

function findByValue(isTime, array, value) {
    if (isTime) {
        if (value === TIMELINE_MAX_VALUE) {
            value = 0;
        }

        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] > value) {
                return true;
            }
        }
    } else {
        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] >= value) {
                return true;
            }
        }
    }

    return false;
}

function refresh() {
    'use strict';
    //Erase the previous time
    context.clearRect(0, 0, context.canvas.width, context.canvas.height);

    //Import the current time
    var date = getDate();
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var hour = hours + minutes / 60;
    var minute = minutes + seconds / 60;
    var milliseconds = seconds + date.getMilliseconds()/1000.0;
    var frame = parseInt(date.getMilliseconds()/(1000/frameRate));
    var angle;
    var text;
    var extent;
    var nextX;

    hours = hours > 12 ? hours - 12 : hours;
    currentFrame = (date.getHours() * frameRate * 60 * 60) + (minutes * frameRate * 60) + (seconds * frameRate) + frame;
    context.save();

    gImage.src = '' + Background1ButtonImage[Background1ButtonIndex];
    context.drawImage(img4png, 0, 0, 360, 360);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "bold 20px GearApplemint";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#000000";
    text = ((date.getDate()<10) ? "0"+date.getDate() : date.getDate().toString());
    context.fillText(text, 288, 180);
    context.restore();
    context.save();

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(179, 180);
    context.rotate(angle);
    imghrpng.src = "hr.png";
    context.drawImage(imghrpng, -35, -180, 71, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(179, 180);
    context.rotate(angle);
    imgminpng.src = "min.png";
    context.drawImage(imgminpng, -22, -180, 45, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((seconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(179, 180);
    context.rotate(angle);
    imgsecpng.src = "sec.png";
    context.drawImage(imgsecpng, -22, -180, 45, 360);
    context.restore();
    context.save();

    context.restore();
    window.requestAnimationFrame(refresh);
    refreshCount++;
}

window.onload = function () {
    'use strict';
    canvas = document.getElementById('clock');
    console.log('onload called');
    context = canvas.getContext('2d');

    canvas.width = document.width;
    canvas.height = document.height;

    WIDTH = document.width;
    HEIGHT = document.height;

    gImage = new Image();

    battery = navigator.battery || navigator.webkitBattery || navigator.mozBattery;

    //add eventListener for tizenhwkey
    window.addEventListener('tizenhwkey', function (e) {
        if (e.keyName == 'back') {
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (err) {
                console.log('Error: ', err.message);
            }
        }
    });

    window.requestAnimationFrame(refresh);

    window.addEventListener('touchstart', function (e) {
        if (e.changedTouches[0].clientX >= Background1ButtonArea[0] && e.changedTouches[0].clientX < Background1ButtonArea[2] && e.changedTouches[0].clientY >= Background1ButtonArea[1] && e.changedTouches[0].clientY < Background1ButtonArea[3]) {
            Background1ButtonIndex++;
            if (Background1ButtonIndex >= Background1ButtonImage.length) {
                Background1ButtonIndex = 0;
            }
        }
    });
};
